com.jnape.palatable.lambda.monoid.builtin

## Class Endo<A>

- java.lang.Object
- - com.jnape.palatable.lambda.monoid.builtin.Endo<A>

- Type Parameters:
    `A` - the input/output type to the `Fn1`
  All Implemented Interfaces:
    Fn1<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>>, Fn2<Fn1<A,A>,Fn1<A,A>,Fn1<A,A>>, Applicative<Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<Fn1<A,A>,?>>, Cartesian<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<?,?>>, Cocartesian<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<?,?>>, Contravariant<Fn1<A,A>,Profunctor<?,Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<?,?>>>, Functor<Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<Fn1<A,A>,?>>, Profunctor<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<?,?>>, Monad<Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<Fn1<A,A>,?>>, MonadReader<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<Fn1<A,A>,?>>, MonadRec<Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<Fn1<A,A>,?>>, MonadWriter<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>,Fn1<Fn1<A,A>,?>>, Monoid<Fn1<A,A>>, Semigroup<Fn1<A,A>>

      public final class Endo<A>
      extends Object
      implements Monoid<Fn1<A,A>>

  A `Monoid` formed by `Fn1` under composition.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Fn2<Fn1<A,A>,A,A>` | `apply(Fn1<A,A> f)` Partially apply this function by passing its first argument.
    `A` | `apply(Fn1<A,A> f, Fn1<A,A> g, A a)`
    `Fn1<A,A>` | `checkedApply(Fn1<A,A> f, Fn1<A,A> g)`
    `static <A> Endo<A>` | `endo()`
    `static <A> Fn2<Fn1<A,A>,A,A>` | `endo(Fn1<A,A> f)`
    `static <A> Fn1<A,A>` | `endo(Fn1<A,A> f, Fn1<A,A> g)`
    `static <A> A` | `endo(Fn1<A,A> f, Fn1<A,A> g, A a)`
    `Fn1<A,A>` | `identity()` The identity element of this monoid.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monoid.Monoid

      `flip, foldLeft, foldMap, foldRight, monoid, monoid, reduceLeft, reduceRight`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `apply, checkedApply, compose, contraMap, curried, curry, diMapL, discardR, fn2, fromBiFunction, toBiFunction, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### apply

          public A apply(Fn1<A,A> f,
                         Fn1<A,A> g,
                         A a)

    - #### identity

          public Fn1<A,A> identity()

      Description copied from interface: `Monoid`
      The identity element of this monoid.
      Specified by:
        `identity` in interface `Monoid<Fn1<A,A>>`
      Returns:
        the identity

    - #### checkedApply

          public Fn1<A,A> checkedApply(Fn1<A,A> f,
                                       Fn1<A,A> g)

      Specified by:
        `checkedApply` in interface `Fn2<Fn1<A,A>,Fn1<A,A>,Fn1<A,A>>`

    - #### apply

          public Fn2<Fn1<A,A>,A,A> apply(Fn1<A,A> f)

      Description copied from interface: `Fn2`
      Partially apply this function by passing its first argument.
      Specified by:
        `apply` in interface `Fn1<Fn1<A,A>,Fn1<Fn1<A,A>,Fn1<A,A>>>`
      Specified by:
        `apply` in interface `Fn2<Fn1<A,A>,Fn1<A,A>,Fn1<A,A>>`
      Parameters:
        `f` - the first argument
      Returns:
        an `Fn1`<B, C>

    - #### endo

          public static <A> Endo<A> endo()

    - #### endo

          public static <A> Fn2<Fn1<A,A>,A,A> endo(Fn1<A,A> f)

    - #### endo

          public static <A> Fn1<A,A> endo(Fn1<A,A> f,
                                          Fn1<A,A> g)

    - #### endo

          public static <A> A endo(Fn1<A,A> f,
                                   Fn1<A,A> g,
                                   A a)